Loading...
Searching...
No Matches
Opm::FlowProblemBlackoil< TypeTag > Class Template Reference

This problem simulates an input file given in the data format used by the commercial ECLiPSE simulator. More...

`#include <FlowProblemBlackoil.hpp>`

Inheritance diagram for Opm::FlowProblemBlackoil< TypeTag >:

## Public Types

using | FlowProblemType = FlowProblem<TypeTag>
Public Types inherited from Opm::FlowGenericProblem< GetPropType< TypeTag, Properties::GridView >, GetPropType< TypeTag, Properties::FluidSystem > >
using | Scalar
using | TabulatedTwoDFunction
using | TabulatedFunction

## Public Member Functions

| FlowProblemBlackoil (Simulator &simulator)
void | beginEpisode () override
| Called by the simulator before an episode begins.
void | beginTimeStep () override
| Called by the simulator before each time integration.
void | finishInit ()
| Called by the Opm::Simulator in order to initialize the problem.
void | endTimeStep () override
| Called by the simulator after each time integration.
void | endStepApplyAction ()
void | endEpisode () override
| Called by the simulator after the end of an episode.
void | writeReports (const SimulatorTimer &timer)
void | writeOutput (const bool verbose) override
| Write the requested quantities of the current solution into the output files.
void | finalizeOutput ()
void | initialSolutionApplied () override
| Callback used by the model to indicate that the initial solution has been determined for all degrees of freedom.
void | addToSourceDense (RateVector &rate, unsigned globalDofIdx, unsigned timeIdx) const override
template<class LhsEval>
LhsEval | permFactTransMultiplier (const IntensiveQuantities &intQuants, unsigned elementIdx) const
| Calculate the transmissibility multiplier due to porosity reduction.
const InitialFluidState & | initialFluidState (unsigned globalDofIdx) const
std::vector< InitialFluidState > & | initialFluidStates ()
const std::vector< InitialFluidState > & | initialFluidStates () const
const EclipseIO & | eclIO () const
void | setSubStepReport (const SimulatorReportSingle &report)
void | setSimulationReport (const SimulatorReport &report)
InitialFluidState | boundaryFluidState (unsigned globalDofIdx, const int directionId) const
const EclWriterType & | eclWriter () const
EclWriterType & | eclWriter ()
Scalar | maxGasDissolutionFactor (unsigned timeIdx, unsigned globalDofIdx) const
| Returns the maximum value of the gas dissolution factor at the current time for a given degree of freedom.
Scalar | maxOilVaporizationFactor (unsigned timeIdx, unsigned globalDofIdx) const
| Returns the maximum value of the oil vaporization factor at the current time for a given degree of freedom.
bool | recycleFirstIterationStorage () const
| Return if the storage term of the first iteration is identical to the storage term for the solution of the previous time step.
template<class Context>
void | initial (PrimaryVariables &values, const Context &context, unsigned spaceIdx, unsigned timeIdx) const
| Evaluate the initial value for a control volume.
Scalar | drsdtcon (unsigned elemIdx, int episodeIdx) const
bool | drsdtconIsActive (unsigned elemIdx, int episodeIdx) const
template<class Context>
void | boundary (BoundaryRateVector &values, const Context &context, unsigned spaceIdx, unsigned timeIdx) const
| Evaluate the boundary conditions for a boundary segment.
void | readSolutionFromOutputModule (const int restart_step, bool fip_init)
| Read simulator solution state from the outputmodule (used with restart).
Scalar | thresholdPressure (unsigned elem1Idx, unsigned elem2Idx) const
const FlowThresholdPressure< TypeTag > & | thresholdPressure () const
FlowThresholdPressure< TypeTag > & | thresholdPressure ()
const ModuleParams & | moduleParams () const
template<class Serializer>
void | serializeOp (Serializer &serializer)
template<class Context>
Scalar | porosity (const Context &context, unsigned spaceIdx, unsigned timeIdx) const
Scalar | porosity (unsigned globalSpaceIdx, unsigned timeIdx) const
| Direct indexed access to the porosity.
template<class Context>
unsigned | pvtRegionIndex (const Context &context, unsigned spaceIdx, unsigned timeIdx) const
| Returns the index of the relevant region for thermodynmic properties.
unsigned | pvtRegionIndex (unsigned elemIdx) const
| Returns the index the relevant PVT region given a cell index.
Public Member Functions inherited from Opm::FlowProblem< TypeTag >
| FlowProblem (Simulator &simulator)
void | prefetch (const Element &elem) const
template<class Restarter>
void | deserialize (Restarter &res)
| This method restores the complete state of the problem and its sub-objects from disk.
template<class Restarter>
void | serialize (Restarter &res)
| This method writes the complete state of the problem and its subobjects to disk.
int | episodeIndex () const
void | beginIteration ()
| Called by the simulator before each Newton-Raphson iteration.
void | endIteration ()
| Called by the simulator after each Newton-Raphson iteration.
template<class Context>
const DimMatrix & | intrinsicPermeability (const Context &context, unsigned spaceIdx, unsigned timeIdx) const
const DimMatrix & | intrinsicPermeability (unsigned globalElemIdx) const
| This method returns the intrinsic permeability tensor given a global element index.
template<class Context>
Scalar | transmissibility (const Context &context, unsigned fromDofLocalIdx, unsigned toDofLocalIdx) const
Scalar | transmissibility (unsigned globalCenterElemIdx, unsigned globalElemIdx) const
| Direct access to the transmissibility between two elements.
template<class Context>
Scalar | diffusivity (const Context &context, unsigned fromDofLocalIdx, unsigned toDofLocalIdx) const
Scalar | diffusivity (const unsigned globalCellIn, const unsigned globalCellOut) const
| give the transmissibility for a face i.e.
Scalar | dispersivity (const unsigned globalCellIn, const unsigned globalCellOut) const
| give the dispersivity for a face i.e.
Scalar | thermalTransmissibilityBoundary (const unsigned globalSpaceIdx, const unsigned boundaryFaceIdx) const
| Direct access to a boundary transmissibility.
template<class Context>
Scalar | transmissibilityBoundary (const Context &elemCtx, unsigned boundaryFaceIdx) const
Scalar | transmissibilityBoundary (const unsigned globalSpaceIdx, const unsigned boundaryFaceIdx) const
| Direct access to a boundary transmissibility.
Scalar | thermalHalfTransmissibility (const unsigned globalSpaceIdxIn, const unsigned globalSpaceIdxOut) const
template<class Context>
Scalar | thermalHalfTransmissibilityIn (const Context &context, unsigned faceIdx, unsigned timeIdx) const
template<class Context>
Scalar | thermalHalfTransmissibilityOut (const Context &context, unsigned faceIdx, unsigned timeIdx) const
template<class Context>
Scalar | thermalHalfTransmissibilityBoundary (const Context &elemCtx, unsigned boundaryFaceIdx) const
const Vanguard::TransmissibilityType & | eclTransmissibilities () const
| Return a reference to the object that handles the "raw" transmissibilities.
const TracerModel & | tracerModel () const
TracerModel & | tracerModel ()
template<class Context>
Scalar | porosity (const Context &context, unsigned spaceIdx, unsigned timeIdx) const
template<class Context>
Scalar | dofCenterDepth (const Context &context, unsigned spaceIdx, unsigned timeIdx) const
| Returns the depth of an degree of freedom [m].
Scalar | dofCenterDepth (unsigned globalSpaceIdx) const
| Direct indexed acces to the depth of an degree of freedom [m].
template<class Context>
Scalar | rockCompressibility (const Context &context, unsigned spaceIdx, unsigned timeIdx) const
template<class Context>
Scalar | rockReferencePressure (const Context &context, unsigned spaceIdx, unsigned timeIdx) const
Scalar | rockReferencePressure (unsigned globalSpaceIdx) const
template<class Context>
const MaterialLawParams & | materialLawParams (const Context &context, unsigned spaceIdx, unsigned timeIdx) const
const MaterialLawParams & | materialLawParams (unsigned globalDofIdx) const
const MaterialLawParams & | materialLawParams (unsigned globalDofIdx, FaceDir::DirEnum facedir) const
template<class Context>
const SolidEnergyLawParams & | solidEnergyLawParams (const Context &context, unsigned spaceIdx, unsigned timeIdx) const
| Return the parameters for the energy storage law of the rock.
template<class Context>
const ThermalConductionLawParams & | thermalConductionLawParams (const Context &context, unsigned spaceIdx, unsigned timeIdx) const
std::shared_ptr< const EclMaterialLawManager > | materialLawManager () const
| Returns the ECL material law manager.
template<class FluidState, class ... Args>
void | updateRelperms (std::array< Evaluation, numPhases > &mobility, DirectionalMobilityPtr &dirMob, FluidState &fluidState, unsigned globalSpaceIdx) const
std::shared_ptr< EclMaterialLawManager > | materialLawManager ()
template<class Context>
unsigned | pvtRegionIndex (const Context &context, unsigned spaceIdx, unsigned timeIdx) const
| Returns the index of the relevant region for thermodynmic properties.
template<class Context>
unsigned | satnumRegionIndex (const Context &context, unsigned spaceIdx, unsigned timeIdx) const
| Returns the index of the relevant region for thermodynmic properties.
template<class Context>
unsigned | miscnumRegionIndex (const Context &context, unsigned spaceIdx, unsigned timeIdx) const
| Returns the index of the relevant region for thermodynmic properties.
template<class Context>
unsigned | plmixnumRegionIndex (const Context &context, unsigned spaceIdx, unsigned timeIdx) const
| Returns the index of the relevant region for thermodynmic properties.
template<class Context>
Scalar | maxPolymerAdsorption (const Context &context, unsigned spaceIdx, unsigned timeIdx) const
| Returns the max polymer adsorption value.
std::string | name () const
| The problem name.
template<class Context>
Scalar | temperature (const Context &context, unsigned spaceIdx, unsigned timeIdx) const
Scalar | temperature (unsigned globalDofIdx, unsigned) const
const SolidEnergyLawParams & | solidEnergyLawParams (unsigned globalSpaceIdx, unsigned) const
const ThermalConductionLawParams & | thermalConductionLawParams (unsigned globalSpaceIdx, unsigned) const
Scalar | maxOilSaturation (unsigned globalDofIdx) const
| Returns an element's historic maximum oil phase saturation that was observed during the simulation.
void | setMaxOilSaturation (unsigned globalDofIdx, Scalar value)
| Sets an element's maximum oil phase saturation observed during the simulation.
template<class Context>
void | source (RateVector &rate, const Context &context, unsigned spaceIdx, unsigned timeIdx) const
| Evaluate the source term for all phases within a given sub-control-volume.
void | source (RateVector &rate, unsigned globalDofIdx, unsigned timeIdx) const
const WellModel & | wellModel () const
| Returns a reference to the ECL well manager used by the problem.
WellModel & | wellModel ()
const AquiferModel & | aquiferModel () const
AquiferModel & | mutableAquiferModel ()
bool | nonTrivialBoundaryConditions () const
Scalar | nextTimeStepSize () const
| Propose the size of the next time step to the simulator.
template<class LhsEval>
LhsEval | rockCompPoroMultiplier (const IntensiveQuantities &intQuants, unsigned elementIdx) const
| Calculate the porosity multiplier due to water induced rock compaction.
template<class LhsEval>
LhsEval | rockCompTransMultiplier (const IntensiveQuantities &intQuants, unsigned elementIdx) const
| Calculate the transmissibility multiplier due to water induced rock compaction.
template<class LhsEval>
LhsEval | wellTransMultiplier (const IntensiveQuantities &intQuants, unsigned elementIdx) const
| Return the well transmissibility multiplier due to rock changes.
std::pair< BCType, RateVector > | boundaryCondition (const unsigned int globalSpaceIdx, const int directionId) const
template<class Serializer>
void | serializeOp (Serializer &serializer)
bool | shouldWriteOutput () const
| Always returns true.
bool | shouldWriteRestartFile () const
| Returns true if an eWoms restart file should be written to disk.
Scalar | rockCompressibility (unsigned globalSpaceIdx) const
| Direct access to rock compressibility.
Scalar | porosity (unsigned globalSpaceIdx, unsigned timeIdx) const
| Direct indexed access to the porosity.
unsigned | pvtRegionIndex (unsigned elemIdx) const
| Returns the index the relevant PVT region given a cell index.
unsigned | satnumRegionIndex (unsigned elemIdx) const
| Returns the index the relevant saturation function region given a cell index.
unsigned | miscnumRegionIndex (unsigned elemIdx) const
| Returns the index the relevant MISC region given a cell index.
unsigned | plmixnumRegionIndex (unsigned elemIdx) const
| Returns the index the relevant PLMIXNUM (for polymer module) region given a cell index.
Scalar | maxPolymerAdsorption (unsigned elemIdx) const
| Returns the max polymer adsorption value.
Public Member Functions inherited from Opm::FlowGenericProblem< GetPropType< TypeTag, Properties::GridView >, GetPropType< TypeTag, Properties::FluidSystem > >
| FlowGenericProblem (const EclipseState &eclState, const Schedule &schedule, const GridView &gridView)
Scalar | maxWaterSaturation (unsigned globalDofIdx) const
| Returns an element's historic maximum water phase saturation that was observed during the simulation.
Scalar | minOilPressure (unsigned globalDofIdx) const
| Returns an element's historic minimum pressure of the oil phase that was observed during the simulation.
Scalar | overburdenPressure (unsigned elementIdx) const
| Get the pressure of the overburden.
Scalar | referencePorosity (unsigned elementIdx, unsigned timeIdx) const
| Returns the porosity of an element.
Scalar | rockFraction (unsigned elementIdx, unsigned timeIdx) const
| Returns the rockFraction of an element.
void | setPorosity (Scalar poro, unsigned elementIdx, unsigned timeIdx=0)
| Sets the porosity of an element.
Scalar | solventSaturation (unsigned elemIdx) const
| Returns the initial solvent saturation for a given a cell index.
Scalar | solventRsw (unsigned elemIdx) const
| Returns the initial solvent dissolved in water for a given a cell index.
Scalar | polymerConcentration (unsigned elemIdx) const
| Returns the initial polymer concentration for a given a cell index.
Scalar | polymerMolecularWeight (const unsigned elemIdx) const
| Returns the polymer molecule weight for a given cell index.
Scalar | microbialConcentration (unsigned elemIdx) const
| Returns the initial microbial concentration for a given a cell index.
Scalar | oxygenConcentration (unsigned elemIdx) const
| Returns the initial oxygen concentration for a given a cell index.
Scalar | ureaConcentration (unsigned elemIdx) const
| Returns the initial urea concentration for a given a cell index.
Scalar | biofilmVolumeFraction (unsigned elemIdx) const
| Returns the initial biofilm volume fraction for a given a cell index.
Scalar | calciteVolumeFraction (unsigned elemIdx) const
| Returns the initial calcite volume fraction for a given a cell index.
unsigned | pvtRegionIndex (unsigned elemIdx) const
| Returns the index the relevant PVT region given a cell index.
unsigned | satnumRegionIndex (unsigned elemIdx) const
| Returns the index the relevant saturation function region given a cell index.
unsigned | miscnumRegionIndex (unsigned elemIdx) const
| Returns the index the relevant MISC region given a cell index.
unsigned | plmixnumRegionIndex (unsigned elemIdx) const
| Returns the index the relevant PLMIXNUM (for polymer module) region given a cell index.
Scalar | maxPolymerAdsorption (unsigned elemIdx) const
| Returns the max polymer adsorption value.
Scalar | rockCompressibility (unsigned globalSpaceIdx) const
| Direct access to rock compressibility.
Scalar | porosity (unsigned globalSpaceIdx, unsigned timeIdx) const
| Direct indexed access to the porosity.
bool | vapparsActive (int episodeIdx) const
int | numPressurePointsEquil () const
bool | operator== (const FlowGenericProblem &rhs) const
void | serializeOp (Serializer &serializer)

## Static Public Member Functions

static void | registerParameters ()
| Registers all available parameters for the problem and the model.
Static Public Member Functions inherited from Opm::FlowProblem< TypeTag >
static void | registerParameters ()
| Registers all available parameters for the problem and the model.
static int | handlePositionalParameter (std::function< void(const std::string &, const std::string &)> addKey, std::set< std::string > &seenParams, std::string &errorMsg, int, const char **argv, int paramIdx, int)
| Handles positional command line parameters.
static std::string | briefDescription ()
| Returns a human readable description of the problem for the help message.
static std::string | helpPreamble (int, const char **argv)
| Returns the string that is printed before the list of command line parameters in the help message.
Static Public Member Functions inherited from Opm::FlowGenericProblem< GetPropType< TypeTag, Properties::GridView >, GetPropType< TypeTag, Properties::FluidSystem > >
static FlowGenericProblem | serializationTestObject (const EclipseState &eclState, const Schedule &schedule, const GridView &gridView)
static std::string | helpPreamble (int, const char **argv)
| Returns the string that is printed before the list of command line parameters in the help message.
static std::string | briefDescription ()
| Returns a human readable description of the problem for the help message.
static void | setBriefDescription (const std::string &msg)
| Specifies the string returned by briefDescription().

## Protected Member Functions

void | updateExplicitQuantities_ (int episodeIdx, int timeStepSize, const bool first_step_after_restart) override
void | updateMaxPolymerAdsorption_ ()
bool | updateMaxPolymerAdsorption_ (unsigned compressedDofIdx, const IntensiveQuantities &iq)
void | computeAndSetEqWeights_ ()
bool | updateCompositionChangeLimits_ ()
void | readEclRestartSolution_ ()
void | readEquilInitialCondition_ () override
void | readExplicitInitialCondition_ () override
void | processRestartSaturations_ (InitialFluidState &elemFluidState, Scalar &solventSaturation)
void | readInitialCondition_ () override
void | handleSolventBC (const BCProp::BCFace &bc, RateVector &rate) const override
void | handlePolymerBC (const BCProp::BCFace &bc, RateVector &rate) const override
void | handleMicrBC (const BCProp::BCFace &bc, RateVector &rate) const override
void | handleOxygBC (const BCProp::BCFace &bc, RateVector &rate) const override
void | handleUreaBC (const BCProp::BCFace &bc, RateVector &rate) const override
void | updateExplicitQuantities_ (const bool first_step_after_restart)
bool | satfuncConsistencyRequirementsMet () const
Protected Member Functions inherited from Opm::FlowProblem< TypeTag >
template<class UpdateFunc>
void | updateProperty_ (const std::string &failureMsg, UpdateFunc func)
bool | updateMaxOilSaturation_ ()
bool | updateMaxOilSaturation_ (unsigned compressedDofIdx, const IntensiveQuantities &iq)
bool | updateMaxWaterSaturation_ ()
bool | updateMaxWaterSaturation_ (unsigned compressedDofIdx, const IntensiveQuantities &iq)
bool | updateMinPressure_ ()
bool | updateMinPressure_ (unsigned compressedDofIdx, const IntensiveQuantities &iq)
std::function< std::vector< double >(const FieldPropsManager &, const std::string &)> | fieldPropDoubleOnLeafAssigner_ ()
template<typename IntType>
std::function< std::vector< IntType >(const FieldPropsManager &, const std::string &, bool)> | fieldPropIntTypeOnLeafAssigner_ ()
void | readMaterialParameters_ ()
void | readThermalParameters_ ()
void | updateReferencePorosity_ ()
bool | updateHysteresis_ ()
bool | updateHysteresis_ (unsigned compressedDofIdx, const IntensiveQuantities &iq)
Scalar | getRockCompTransMultVal (std::size_t dofIdx) const
void | updatePffDofData_ ()
void | readBoundaryConditions_ ()
Scalar | limitNextTimeStepSize_ (Scalar dtNext) const
int | refPressurePhaseIdx_ () const
void | updateRockCompTransMultVal_ ()
template<class LhsEval>
LhsEval | computeRockCompTransMultiplier_ (const IntensiveQuantities &intQuants, unsigned elementIdx) const
| Calculate the transmissibility multiplier due to water induced rock compaction.
Protected Member Functions inherited from Opm::FlowGenericProblem< GetPropType< TypeTag, Properties::GridView >, GetPropType< TypeTag, Properties::FluidSystem > >
void | initFluidSystem_ ()
bool | shouldWriteOutput () const
| Always returns true.
bool | shouldWriteRestartFile () const
| Returns true if an eWoms restart file should be written to disk.
bool | beginEpisode_ (bool enableExperiments, int episodeIdx)
void | beginTimeStep_ (bool enableExperiments, int episodeIdx, int timeStepIndex, Scalar startTime, Scalar time, Scalar timeStepSize, Scalar endTime)
void | readRockParameters_ (const std::vector< Scalar > &cellCenterDepths, std::function< std::array< int, 3 >(const unsigned)> ijkIndex)
void | readRockCompactionParameters_ ()
void | readBlackoilExtentionsInitialConditions_ (std::size_t numDof, bool enableSolvent, bool enablePolymer, bool enablePolymerMolarWeight, bool enableBioeffects, bool enableMICP)
void | updatePvtnum_ ()
void | updateSatnum_ ()
void | updateMiscnum_ ()
void | updatePlmixnum_ ()
std::function< unsigned(unsigned)> | lookupIdxOnLevelZeroAssigner_ ()

## Protected Attributes

FlowThresholdPressure< TypeTag > | thresholdPressures_
std::vector< InitialFluidState > | initialFluidStates_
bool | enableEclOutput_
std::unique_ptr< EclWriterType > | eclWriter_
const Scalar | smallSaturationTolerance_ = 1.e-6
MixingRateControls< FluidSystem > | mixControls_
ActionHandler< Scalar, IndexTraits > | actionHandler_
ModuleParams | moduleParams_
HybridNewton | hybridNewton_
Protected Attributes inherited from Opm::FlowProblem< TypeTag >
Vanguard::TransmissibilityType | transmissibilities_
std::shared_ptr< EclMaterialLawManager > | materialLawManager_
std::shared_ptr< EclThermalLawManager > | thermalLawManager_
GlobalEqVector | drift_
WellModel | wellModel_
AquiferModel | aquiferModel_
PffGridVector< GridView, Stencil, PffDofData_, DofMapper > | pffDofData_
TracerModel | tracerModel_
BCData< int > | bcindex_
bool | nonTrivialBoundaryConditions_ = false
bool | first_step_ = true
Protected Attributes inherited from Opm::FlowGenericProblem< GetPropType< TypeTag, Properties::GridView >, GetPropType< TypeTag, Properties::FluidSystem > >
const EclipseState & | eclState_
const Schedule & | schedule_
const GridView & | gridView_
std::array< std::vector< Scalar >, 2 > | referencePorosity_
std::vector< int > | pvtnum_
std::vector< unsigned short > | satnum_
std::vector< unsigned short > | miscnum_
std::vector< unsigned short > | plmixnum_
std::vector< RockParams > | rockParams_
std::vector< unsigned short > | rockTableIdx_
std::vector< TabulatedTwoDFunction > | rockCompPoroMultWc_
std::vector< TabulatedTwoDFunction > | rockCompTransMultWc_
std::vector< TabulatedFunction > | rockCompPoroMult_
std::vector< TabulatedFunction > | rockCompTransMult_
std::vector< Scalar > | rockCompTransMultVal_
PolymerSolutionContainer< Scalar > | polymer_
std::vector< Scalar > | maxOilSaturation_
std::vector< Scalar > | maxWaterSaturation_
std::vector< Scalar > | minRefPressure_
std::vector< Scalar > | overburdenPressure_
std::vector< Scalar > | solventSaturation_
std::vector< Scalar > | solventRsw_
BioeffectsSolutionContainer< Scalar > | bioeffects_
bool | enableTuning_
Scalar | initialTimeStepSize_
Scalar | maxTimeStepAfterWellEvent_
int | numPressurePointsEquil_
bool | enableDriftCompensation_
bool | explicitRockCompaction_
const LookUpData | lookUpData_

## Additional Inherited Members

Protected Types inherited from Opm::FlowProblem< TypeTag >
enum | { dim = GridView::dimension }
enum | { dimWorld = GridView::dimensionworld }
enum | { numEq = getPropValue<TypeTag, Properties::NumEq>() }
enum | { numPhases = FluidSystem::numPhases }
enum | { numComponents = FluidSystem::numComponents }
enum | { enableBioeffects = getPropValue<TypeTag, Properties::EnableBioeffects>() }
enum | { enableBrine = getPropValue<TypeTag, Properties::EnableBrine>() }
enum | { enableConvectiveMixing = getPropValue<TypeTag, Properties::EnableConvectiveMixing>() }
enum | { enableDiffusion = getPropValue<TypeTag, Properties::EnableDiffusion>() }
enum | { enableDispersion = getPropValue<TypeTag, Properties::EnableDispersion>() }
enum | { enableEnergy = getPropValue<TypeTag, Properties::EnableEnergy>() }
enum | { enableExperiments = getPropValue<TypeTag, Properties::EnableExperiments>() }
enum | { enableExtbo = getPropValue<TypeTag, Properties::EnableExtbo>() }
enum | { enableFoam = getPropValue<TypeTag, Properties::EnableFoam>() }
enum | { enableMICP = Indices::enableMICP }
enum | { enablePolymer = getPropValue<TypeTag, Properties::EnablePolymer>() }
enum | { enablePolymerMolarWeight = getPropValue<TypeTag, Properties::EnablePolymerMW>() }
enum | { enableSaltPrecipitation = getPropValue<TypeTag, Properties::EnableSaltPrecipitation>() }
enum | { enableSolvent = getPropValue<TypeTag, Properties::EnableSolvent>() }
enum | { enableTemperature = getPropValue<TypeTag, Properties::EnableTemperature>() }
enum | { enableThermalFluxBoundaries = getPropValue<TypeTag, Properties::EnableThermalFluxBoundaries>() }
enum | { gasPhaseIdx = FluidSystem::gasPhaseIdx }
enum | { oilPhaseIdx = FluidSystem::oilPhaseIdx }
enum | { waterPhaseIdx = FluidSystem::waterPhaseIdx }
enum | { gasCompIdx = FluidSystem::gasCompIdx }
enum | { oilCompIdx = FluidSystem::oilCompIdx }
enum | { waterCompIdx = FluidSystem::waterCompIdx }
using | BaseType
using | ParentType = GetPropType<TypeTag, Properties::BaseProblem>
using | Implementation = GetPropType<TypeTag, Properties::Problem>
using | Scalar = GetPropType<TypeTag, Properties::Scalar>
using | GridView = GetPropType<TypeTag, Properties::GridView>
using | Stencil = GetPropType<TypeTag, Properties::Stencil>
using | FluidSystem = GetPropType<TypeTag, Properties::FluidSystem>
using | GlobalEqVector = GetPropType<TypeTag, Properties::GlobalEqVector>
using | EqVector = GetPropType<TypeTag, Properties::EqVector>
using | Vanguard = GetPropType<TypeTag, Properties::Vanguard>
using | Indices = GetPropType<TypeTag, Properties::Indices>
using | PrimaryVariables = GetPropType<TypeTag, Properties::PrimaryVariables>
using | RateVector = GetPropType<TypeTag, Properties::RateVector>
using | Simulator = GetPropType<TypeTag, Properties::Simulator>
using | Element = typename GridView::template Codim<0>::Entity
using | ElementContext = GetPropType<TypeTag, Properties::ElementContext>
using | EclMaterialLawManager = typename GetProp<TypeTag, Properties::MaterialLaw>::EclMaterialLawManager
using | EclThermalLawManager = typename GetProp<TypeTag, Properties::SolidEnergyLaw>::EclThermalLawManager
using | MaterialLawParams = typename EclMaterialLawManager::MaterialLawParams
using | SolidEnergyLawParams = typename EclThermalLawManager::SolidEnergyLawParams
using | ThermalConductionLawParams = typename EclThermalLawManager::ThermalConductionLawParams
using | MaterialLaw = GetPropType<TypeTag, Properties::MaterialLaw>
using | DofMapper = GetPropType<TypeTag, Properties::DofMapper>
using | Evaluation = GetPropType<TypeTag, Properties::Evaluation>
using | IntensiveQuantities = GetPropType<TypeTag, Properties::IntensiveQuantities>
using | WellModel = GetPropType<TypeTag, Properties::WellModel>
using | AquiferModel = GetPropType<TypeTag, Properties::AquiferModel>
using | Toolbox = MathToolbox<Evaluation>
using | DimMatrix = Dune::FieldMatrix<Scalar, dimWorld, dimWorld>
using | TracerModel = GetPropType<TypeTag, Properties::TracerModel>
using | DirectionalMobilityPtr = Utility::CopyablePtr<DirectionalMobility<TypeTag>>
Protected Types inherited from Opm::FlowGenericProblem< GetPropType< TypeTag, Properties::GridView >, GetPropType< TypeTag, Properties::FluidSystem > >
using | Grid
using | LookUpData
Static Protected Attributes inherited from Opm::FlowGenericProblem< GetPropType< TypeTag, Properties::GridView >, GetPropType< TypeTag, Properties::FluidSystem > >
static std::string | briefDescription_

## Detailed Description

template<class TypeTag>
class Opm::FlowProblemBlackoil< TypeTag >

This problem simulates an input file given in the data format used by the commercial ECLiPSE simulator.

## Constructor & Destructor Documentation

## FlowProblemBlackoil()

template<class TypeTag>

Opm::FlowProblemBlackoil< TypeTag >::FlowProblemBlackoil | ( | Simulator & | simulator | ) |

inline explicit

## Member Function Documentation

## addToSourceDense()

template<class TypeTag>

void Opm::FlowProblemBlackoil< TypeTag >::addToSourceDense | ( | RateVector & | rate,
|  | unsigned | globalDofIdx,
|  | unsigned | timeIdx ) const

inline override virtual

Implements Opm::FlowProblem< TypeTag >.

## beginEpisode()

template<class TypeTag>

void Opm::FlowProblemBlackoil< TypeTag >::beginEpisode | ( |  | ) |

inline override virtual

Called by the simulator before an episode begins.

Reimplemented from Opm::FlowProblem< TypeTag >.

## beginTimeStep()

template<class TypeTag>

void Opm::FlowProblemBlackoil< TypeTag >::beginTimeStep | ( |  | ) |

inline override virtual

Called by the simulator before each time integration.

Reimplemented from Opm::FlowProblem< TypeTag >.

## boundary()

template<class TypeTag>
template<class Context>

void Opm::FlowProblemBlackoil< TypeTag >::boundary | ( | BoundaryRateVector & | values,
|  | const Context & | context,
|  | unsigned | spaceIdx,
|  | unsigned | timeIdx ) const

inline

Evaluate the boundary conditions for a boundary segment.

Parameters

  values | Stores the fluxes over the boundary segment.
  context | The object representing the execution context from which this method is called.
  spaceIdx | The local index of the spatial entity which represents the boundary segment.
  timeIdx | The index used for the time discretization

Reservoir simulation uses no-flow conditions as default for all boundaries.

## endEpisode()

template<class TypeTag>

void Opm::FlowProblemBlackoil< TypeTag >::endEpisode | ( |  | ) |

inline override virtual

Called by the simulator after the end of an episode.

Reimplemented from Opm::FlowProblem< TypeTag >.

## endTimeStep()

template<class TypeTag>

void Opm::FlowProblemBlackoil< TypeTag >::endTimeStep | ( |  | ) |

inline override virtual

Called by the simulator after each time integration.

Reimplemented from Opm::FlowProblem< TypeTag >.

## finishInit()

template<class TypeTag>

void Opm::FlowProblemBlackoil< TypeTag >::finishInit | ( |  | ) |

inline

Called by the Opm::Simulator in order to initialize the problem.

If you overload this method don't forget to call ParentType::finishInit()

## handleMicrBC()

template<class TypeTag>

void Opm::FlowProblemBlackoil< TypeTag >::handleMicrBC | ( | const BCProp::BCFace & | bc,
|  | RateVector & | rate ) const

inline override protected virtual

Implements Opm::FlowProblem< TypeTag >.

## handleOxygBC()

template<class TypeTag>

void Opm::FlowProblemBlackoil< TypeTag >::handleOxygBC | ( | const BCProp::BCFace & | bc,
|  | RateVector & | rate ) const

inline override protected virtual

Implements Opm::FlowProblem< TypeTag >.

## handlePolymerBC()

template<class TypeTag>

void Opm::FlowProblemBlackoil< TypeTag >::handlePolymerBC | ( | const BCProp::BCFace & | bc,
|  | RateVector & | rate ) const

inline override protected virtual

Implements Opm::FlowProblem< TypeTag >.

## handleSolventBC()

template<class TypeTag>

void Opm::FlowProblemBlackoil< TypeTag >::handleSolventBC | ( | const BCProp::BCFace & | bc,
|  | RateVector & | rate ) const

inline override protected virtual

Implements Opm::FlowProblem< TypeTag >.

## handleUreaBC()

template<class TypeTag>

void Opm::FlowProblemBlackoil< TypeTag >::handleUreaBC | ( | const BCProp::BCFace & | bc,
|  | RateVector & | rate ) const

inline override protected virtual

Implements Opm::FlowProblem< TypeTag >.

## initial()

template<class TypeTag>
template<class Context>

void Opm::FlowProblemBlackoil< TypeTag >::initial | ( | PrimaryVariables & | values,
|  | const Context & | context,
|  | unsigned | spaceIdx,
|  | unsigned | timeIdx ) const

inline

Evaluate the initial value for a control volume.

Parameters

  values | Stores the primary variables.
  context | The object representing the execution context from which this method is called.
  spaceIdx | The local index of the spatial entity which represents the boundary segment.
  timeIdx | The index used for the time discretization

The reservoir problem uses a constant boundary condition for the whole domain.

## initialSolutionApplied()

template<class TypeTag>

void Opm::FlowProblemBlackoil< TypeTag >::initialSolutionApplied | ( |  | ) |

inline override virtual

Callback used by the model to indicate that the initial solution has been determined for all degrees of freedom.

Reimplemented from Opm::FlowProblem< TypeTag >.

## permFactTransMultiplier()

template<class TypeTag>
template<class LhsEval>

LhsEval Opm::FlowProblemBlackoil< TypeTag >::permFactTransMultiplier | ( | const IntensiveQuantities & | intQuants,
|  | unsigned | elementIdx ) const

inline

Calculate the transmissibility multiplier due to porosity reduction.

TODO: The API of this is a bit ad-hoc, it would be better to use context objects.

## porosity() [1/2]

template<class TypeTag>
template<class Context>

Scalar Opm::FlowProblem< TypeTag >::porosity | ( | const Context & | context,
|  | unsigned | spaceIdx,
|  | unsigned | timeIdx ) const

inline

For the FlowProblem, this method is identical to referencePorosity(). The intensive quantities object may apply various multipliers (e.g. ones which model rock compressibility and water induced rock compaction) to it which depend on the current physical conditions.

## porosity() [2/2]

template<class TypeTag>

Scalar Opm::FlowGenericProblem< GridView, FluidSystem >::porosity | ( | unsigned | globalSpaceIdx,
|  | unsigned | timeIdx ) const

Direct indexed access to the porosity.

For the FlowProblem, this method is identical to referencePorosity(). The intensive quantities object may apply various multipliers (e.g. ones which model rock compressibility and water induced rock compaction) to it which depend on the current physical conditions.

## readEquilInitialCondition_()

template<class TypeTag>

void Opm::FlowProblemBlackoil< TypeTag >::readEquilInitialCondition_ | ( |  | ) |

inline override protected virtual

Implements Opm::FlowProblem< TypeTag >.

## readExplicitInitialCondition_()

template<class TypeTag>

void Opm::FlowProblemBlackoil< TypeTag >::readExplicitInitialCondition_ | ( |  | ) |

inline override protected virtual

Implements Opm::FlowProblem< TypeTag >.

## readInitialCondition_()

template<class TypeTag>

void Opm::FlowProblemBlackoil< TypeTag >::readInitialCondition_ | ( |  | ) |

inline override protected virtual

Reimplemented from Opm::FlowProblem< TypeTag >.

## readSolutionFromOutputModule()

template<class TypeTag>

void Opm::FlowProblemBlackoil< TypeTag >::readSolutionFromOutputModule | ( | const int | restart_step,
|  | bool | fip_init )

inline

Read simulator solution state from the outputmodule (used with restart).

Parameters

  restart_step | Step to read at
  fip_init | True to do limited simulator initialization

fip_init is used when calculating original FIP from restart state

## recycleFirstIterationStorage()

template<class TypeTag>

bool Opm::FlowProblemBlackoil< TypeTag >::recycleFirstIterationStorage | ( |  | ) | const

inline

Return if the storage term of the first iteration is identical to the storage term for the solution of the previous time step.

For quite technical reasons, the storage term cannot be recycled if either DRSDT or DRVDT are active. Nor if the porosity is changes between timesteps using a pore volume multiplier (i.e., poreVolumeMultiplier() != 1.0)

## registerParameters()

template<class TypeTag>

void Opm::FlowProblemBlackoil< TypeTag >::registerParameters | ( |  | ) |

inline static

Registers all available parameters for the problem and the model.

## thresholdPressure()

template<class TypeTag>

Scalar Opm::FlowProblemBlackoil< TypeTag >::thresholdPressure | ( | unsigned | elem1Idx,
|  | unsigned | elem2Idx ) const

inline

## updateExplicitQuantities_()

template<class TypeTag>

void Opm::FlowProblemBlackoil< TypeTag >::updateExplicitQuantities_ | ( | int | episodeIdx,
|  | int | timeStepSize,
|  | const bool | first_step_after_restart )

inline override protected virtual

Implements Opm::FlowProblem< TypeTag >.

## writeOutput()

template<class TypeTag>

void Opm::FlowProblemBlackoil< TypeTag >::writeOutput | ( | const bool | verbose | ) |

inline override virtual

Write the requested quantities of the current solution into the output files.

Reimplemented from Opm::FlowProblem< TypeTag >.

The documentation for this class was generated from the following file:

- opm/simulators/flow/FlowProblemBlackoil.hpp